function [x, error, niter, flag] = gradient(A, x, b, M, maxit, tol)
flag = 0;    niter = 0;   bnrm2 = norm( b );
if  ( bnrm2 == 0.0 ), bnrm2 = 1.0; end
r = b - A*x;  error = norm( r ) / bnrm2;
if ( error < tol ) return, end
for niter = 1:maxit
    z  = M \ r;  rho = (r'*z);
    q = A*z;               alpha = rho / (z'*q );
    x = x + alpha * z;     r = r - alpha*q;
    error = norm( r ) / bnrm2;  
    if ( error <= tol ), break, end
end
if ( error > tol ) flag = 1; end
return